/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include "promile-qt.h"
#include "ui_promile-qt.h"
#include <string.h>
#define ILOSC_NAPOJOW 100

using namespace Ui;

extern Form ui;
extern char pierwszy_dodany;
class napoj; // deklaracja klasy
float wspolczynnik, waga, ilosc_plynow=0,masa=0,ostatni=0,pierwszy=0, cz=0,ile_na_godz;
napoj * napoje[ILOSC_NAPOJOW];
int co_ile;
int nr_napoju = 0;
char odp,zaawansowane='n';
const float gestosc = 0.79;
int wyswietlono ; //ktory dzien wyswietlono juz

class napoj
{
	public:
		int ilosc;              //objętość napoju [ml]
		int dlugosc_picia;      //czas spożywania teo napoju [minut]
		float stezenie;         //zawartość alkoholu [% v/v]
		float godzina;          //godzina rozpoczęcia picia
		float czas_wchlaniania; //czas po którym alkohol dostaje się do krwi
		float ile_wypite;       //ile ml wypite w danym czasie
		char spr;		//czy wypite całe
		napoj (int,float,float,float,int);
		~napoj();
};

napoj::napoj (int il, float st, float godz, float cz_wchl, int dl_pic)
{
	ilosc=il;
	stezenie=st;
	godzina=godz;
	czas_wchlaniania=cz_wchl;
	ile_wypite=0;
	dlugosc_picia=dl_pic;
	spr='n';
}

napoj::~napoj ()
{
nr_napoju=nr_napoju-1;
ostatni=0;
pierwszy=0;
}

float spytaj_o_plec(char plec)
{


	switch (plec)
	{
		case 'k' :
			return 0.6;
			break;

		case 'm' :
			return 0.7;
			break;

		default :
			return 0.7;
			break;
	}
}

float Form1::m_alk(char tryb='n')  // tryb c-cichy, n-normalny
{	
	int nap; // numer napoju
	char koniec='n';
	float porcja=0,dawka;
	
	cz=pierwszy;
	if (tryb=='n') 
	{
	co_ile=ui.spinBox_co_ile->value();
	}
	else co_ile=1; //jezeli wyniki nie maja byc wyswietlane to licz co od minuty
	masa=0;
	while ( (cz<ostatni) || (cz >= ostatni &&  koniec == 'n' ))
	{
		for (nap=1 ; nap<=nr_napoju ; nap++)
		{dawka=0;
			if ((cz > napoje[nap]->godzina) && (napoje[nap]->spr=='n'))
			{
				porcja=napoje[nap]->ilosc/( napoje[nap]->czas_wchlaniania*\
						napoje[nap]->dlugosc_picia);

				if (napoje[nap]->czas_wchlaniania < napoje[nap]->dlugosc_picia)
				{
					if ( cz < napoje[nap]->godzina + napoje[nap]->czas_wchlaniania)
					{
						dawka=porcja*(cz-napoje[nap]->godzina);

					}
					else
					{
						if ( cz > napoje[nap]->godzina + napoje[nap]->dlugosc_picia)
						{
							dawka=(napoje[nap]->czas_wchlaniania+\
							napoje[nap]->godzina+napoje[nap]->dlugosc_picia-cz)*porcja;
						}
						else {dawka=napoje[nap]->czas_wchlaniania*porcja;}
					}
				}
				else // czas wchlaniania >= dlugosc picia
				{
					if ( cz < napoje[nap]->godzina + napoje[nap]->dlugosc_picia)
					{
						dawka=porcja*(cz-napoje[nap]->godzina);

					}
					else
					{
						if ( cz > napoje[nap]->godzina + napoje[nap]->czas_wchlaniania)
						{
							dawka=((napoje[nap]->czas_wchlaniania+\
							napoje[nap]->godzina+napoje[nap]->dlugosc_picia)-\
									cz)*porcja;
						}
						else {dawka=napoje[nap]->dlugosc_picia*porcja;}
					}

				}
				if (dawka<0) {dawka=0;}
				masa=masa+dawka*gestosc*napoje[nap]->stezenie/100.0;
				napoje[nap]->ile_wypite+=dawka;
				if (napoje[nap]->ile_wypite >= napoje[nap]->ilosc)
				{napoje[nap]->spr='t';}
			}

		}
		if (ui.radioButton_stala_szybkosc->isChecked())
		{
			masa=masa-(ile_na_godz/60.0);
		}
		else
		{	if (masa<5.8)
			{
			masa=masa-5.8/60;
			}
			else
			masa=masa-((ui.doubleSpinBox_maxg_na_godz->value()*masa) / (4.2+masa))/60.0;
		}
		if (masa<0){masa=0;}
		if ( (((int) (cz - pierwszy) %  co_ile == 0) || cz == pierwszy) && tryb=='n')
		{
	//		printf("\"%f\",\"%f\"\n",cz,masa/waga/wspolczynnik);
			wyswietl_wynik(masa/ilosc_plynow);
			ui.progressBar->setValue(int (cz/ostatni*100));
		}

		if (cz > ostatni && masa==0 && ((int) (cz - pierwszy) % co_ile==0)) {koniec='t';}
		cz++;
	}



	// oznaczanie jako niewypite
	for (nap=1 ; nap<=nr_napoju ; nap++)
	{
		napoje[nap]->spr='n';
		napoje[nap]->ile_wypite=0;
	}
	ui.progressBar->setValue(100);
return cz;
}

void Form1::dodaj_napoj(int ilosc, float godzina, float stezenie, float cz_wchl, int dl_pic, char czy_oblicz='n')
{

		nr_napoju++;
		if (nr_napoju==1)
		{
			pierwszy=godzina; // ustawienie pierwszego napoju
		}
		else
		{
			if(godzina<pierwszy) {pierwszy=godzina;}
		}
		
		if (nr_napoju>=ILOSC_NAPOJOW)
		{
			ui.textBrowser_napoje->append(QString::fromUtf8("\n<font color=red><b>Osiągnięto limit napojów</b></font>"));
			nr_napoju--;
			return;
		}

		napoje[nr_napoju] = new napoj(ilosc,stezenie,godzina,cz_wchl,dl_pic);

		ui.textBrowser_napoje->append("<b>Dodano " + QString::number(nr_napoju) + QString::fromUtf8(" napój: </b>") + QString::number(ilosc) +  " ml " + QString::number(ui.doubleSpinBox_zawartosc->value()) + QString::fromUtf8(" % dzień ") + QString::number(ui.spinBox_czas_dzien->value()) +" godzina " + QString::number(ui.spinBox_czas_godz->value()) + ":" + QString::number(ui.spinBox_czas_min->value()));
		
		
			if ( godzina + dl_pic + cz_wchl > ostatni )
			{
				ostatni = godzina + cz_wchl + dl_pic; // godzina wchloniecia ostatniego napoju
			}
	
		if (((czy_oblicz == 'n') && (nr_napoju == 1)) || ui.tabWidget_3->currentIndex()==1 )
		{
			pierwszy_dodany='t';
		}

		
		if (pierwszy_dodany=='t')
		{
		if (ui.spinBox_ilosc->value()<=50) // jeżeli kieliszek
                {
			godzina=godzina+ui.spinBox_czas_kieliszki->value()+dl_pic;
		}
		else
		{
			godzina=godzina+dl_pic;
		}
			ustaw_czas_rozpoczecia((int) godzina);
		}
}


void kasuj_napoje(void)
{
	int nap;
	int ilosc_napoi;
	ilosc_napoi=nr_napoju;
	for (nap=1; nap<=ilosc_napoi;nap++)
	{
		napoje[nap]->~napoj();		
	}
}


void Form1::wyswietl_tytul_tabeli()
{
ui.textBrowser_wynik->insertHtml(QString::fromUtf8("<table border=\"0\" width=\"300\"><tr><td><b>Godzina</b></td><td><b>Stężenie we krwi [&permil;]</b></td></tr></table>"));

}

void Form1::wyswietl_wynik(float wynik)
{		char  o1[100], o2[100], z1[100],z2[100]; //znaczniki otwierające i zamykające
		int godziny,minuty,dzien;
		char wyswietl[150];
		dzien = int (cz/(24*60.0));
		godziny = int (cz - 24*60*dzien)/60;
		minuty = int (cz - 24*60*dzien - godziny*60);
		dzien=dzien+1; //aby pierwszy dzien by? 1 a nie 0		
		
		if (wyswietlono != dzien)
		{
			ui.textBrowser_wynik->append("\n");
			ui.textBrowser_wynik->insertHtml(QString::fromUtf8("<b>Dzień ") + QString::number(dzien) + "</b>");
			wyswietlono=dzien;
		}	

		if ((wynik>=ui.doubleSpinBox_dop_stez->value() && wynik>0)) //wyświetl na czerwono jeśli poqyżęj dopuszczalnego st??enia
		{
			sprintf(o1,"<table border=\"0\" width=\"300\"><tr><p><td><font color=red>");
			sprintf(z1,"</font></td>");
			sprintf(o2,"<td><font color=red>");
			sprintf(z2,"</font></td></p></tr><table>");
		}
		else
		if (wynik==0) // na zielono kiedy 0 promili
		{
			sprintf(o1,"<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#00CC00\">");
			sprintf(z1,"</font></td>");
			sprintf(o2,"<td><font color=\"#00CC00\">");
			sprintf(z2,"</font></td></p></tr><table>");
		}
		else
		{
			sprintf(o1,"<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#FF7700\">"); // na pomara?czowo kiedy 0<promile<dopuszczalne
			sprintf(z1,"</font></td>");
			sprintf(o2,"<td><font color=\"#FF7700\">");
			sprintf(z2,"</font></td></p></tr><table>");
		}

		if (wynik>=ui.doubleSpinBox_dawka_smiertelna->value())
		{
		sprintf(wyswietl, "%s%s%02i%s%02i%s%s%.3f%s%s" ,"<b>", o1,godziny ,":",minuty,z1,o2, wynik,z2,"</b>");
		}
		else
		{
		sprintf(wyswietl, "%s%02i%s%02i%s%s%.3f%s" , o1,godziny ,":",minuty,z1,o2, wynik,z2);
		}
		ui.textBrowser_wynik->insertHtml(wyswietl);
}


float Form1::tluszcz(float waga)
{
	float ilosc_tluszczu=0;
	float h2=(ui.spinBox_wzrost->value()/100.0)*(ui.spinBox_wzrost->value()/100.0);
	float bmi=waga/h2;
	if (bmi>25)
	{
		ilosc_tluszczu=(bmi-25)*h2;
	}
	if (bmi<18.5)
	{
		ilosc_tluszczu=(bmi-18.5)*h2;
	}
	return ilosc_tluszczu;
}

void Form1::bmi_info(float waga)
{
	float h2=(ui.spinBox_wzrost->value()/100.0)*(ui.spinBox_wzrost->value()/100.0);
	float bmi=(waga/h2);

	if (bmi>25)
	{
		ui.textBrowser_wynik->insertHtml(QString::fromUtf8("\nTwój indeks masy ciała wynosi ") + QString::number(bmi) + QString::fromUtf8(" i może wskazywać na nadwagę.\nDlatego program skorygował zawartość płynów ustrojowych.\nJeśli nie masz nadwagi - zaznacz opcję \"nie uwzględniaj współczynnika BMI\""));
	}

	if (bmi<18.5)
	{
		ui.textBrowser_wynik->insertHtml(QString::fromUtf8("\nTwój indeks masy ciała wynosi ")+ QString::number(bmi) + QString::fromUtf8(" i może wskazywać na niedowagę. \nDlatego program skorygował zawartość płynow ustrojowych.\nJeśli nie masz niedowagi - zaznacz opcję \"nie uwzględniaj współczynnika BMI\""));
	}

}

//////////////////////////////////////
//             M A I N              //
//////////////////////////////////////


int Form1::czas_na_minuty(int dzien, int godzina, int minuta)
{
	int czas;
	czas=(dzien-1)*24*60+godzina*60+minuta;
	return czas;
}

void Form1::oblicz_ile_moge_wypic(int waga,char plec)
{
	float objetosc=0;
	int koniec_picia=0;
	int cz_wchl;
	int cz_rozp;
	int cz_zak;
	int ilosc_porcji=0;
	int porcja=0;
	char porcje[200],p2[20],p3[20];
	int czesc_porcji=4; // 4/4
	int czas_picia; //sumaryczny czas picia
	wspolczynnik=spytaj_o_plec(plec);
	if (ui.checkBox_bmi->isChecked())
	{
		ilosc_plynow=waga*wspolczynnik;
	}
	else
	{
		ilosc_plynow=oblicz_ilosc_plynow(waga,wspolczynnik);
	}
	ile_na_godz=ui.doubleSpinBox_prom_na_godz->value()*ilosc_plynow;
	cz_wchl=ui.spinBox_cz_wchl_godz->value()*60+ui.spinBox_cz_wchl_min->value();
	cz_rozp=czas_na_minuty(ui.spinBox_czas_dzien->value(),ui.spinBox_czas_godz->value(),\
	ui.spinBox_czas_min->value());
	cz_zak=czas_na_minuty(ui.spinBox_czas_dzien_2->value(),ui.spinBox_czas_godz_2->value(),\
	ui.spinBox_czas_min_2->value());
	czas_picia=cz_zak-cz_rozp;
	if (czas_picia<240)
	{
		ui.textBrowser_wynik->clear();
		ui.textBrowser_wynik->insertHtml("Podaj czas picia co najmniej 4 godziny");
		return;
	}
	


	if (nr_napoju!=0)
	{
		kasuj('t');
	}

	// WSTEPNE SZACOWANIE

	while (koniec_picia<=cz_zak)
	{
		cz_rozp=czas_na_minuty(ui.spinBox_czas_dzien->value(),ui.spinBox_czas_godz->value(),\
		ui.spinBox_czas_min->value());
		
		dodaj_napoj(ui.spinBox_ilosc->value(),cz_rozp, ui.doubleSpinBox_zawartosc->value(),\
		cz_wchl,ui.spinBox_dl_pic->value());
		
		koniec_picia=(int) m_alk('c');
		objetosc=objetosc+ui.spinBox_ilosc->value();
		ilosc_porcji++;
	}
	// *******************
	
	if (koniec_picia>cz_zak)
	{
		do
		{
		ustaw_czas_rozpoczecia((int) pierwszy);
		objetosc=0;
		porcja=1;
		kasuj('t');
		while (porcja<ilosc_porcji) // wypicie minimalnej ilosci porcji
		{
			cz_rozp=czas_na_minuty(ui.spinBox_czas_dzien->value(),ui.spinBox_czas_godz->value(),\
			ui.spinBox_czas_min->value());

			dodaj_napoj(ui.spinBox_ilosc->value(),cz_rozp, ui.doubleSpinBox_zawartosc->value(),\
			cz_wchl,ui.spinBox_dl_pic->value());

			objetosc=objetosc+ui.spinBox_ilosc->value();
			porcja++;
		}

			cz_rozp=czas_na_minuty(ui.spinBox_czas_dzien->value(),ui.spinBox_czas_godz->value(),\
			ui.spinBox_czas_min->value());
			
			czesc_porcji=czesc_porcji-1;
			objetosc=objetosc+czesc_porcji/4.0*ui.spinBox_ilosc->value();

			dodaj_napoj(int (ui.spinBox_ilosc->value()*czesc_porcji/4.0),cz_rozp,\
			ui.doubleSpinBox_zawartosc->value(),cz_wchl,ui.spinBox_dl_pic->value());

			koniec_picia=(int) m_alk('c');
			
			
		}
		while (koniec_picia>cz_zak);
		
		switch (czesc_porcji)
		{
			case 3:
				sprintf(p2,"%s"," 3/4");
				break;
			case 2:
				sprintf(p2,"%s"," 1/2");
				break;
			case 1:
				sprintf(p2,"%s"," 1/4");
				break;
			case 0:
				sprintf(p2,"%s","");
				break;

		}



		if (ilosc_porcji-1==0 )
		{
			sprintf(p3,"%s","");
		}
		else
		{
			if (czesc_porcji==0)
			{
				sprintf (p3,"%i",ilosc_porcji-1);
			}
			else
			sprintf (p3,"%i%s",ilosc_porcji-1," i ");
		}
		sprintf(porcje,"%s%s",p3,p2);

		if (ui.comboBox_ilosc->currentIndex() != 0) // je?eli wybrane jest opakowanie
		{
			ui.textBrowser_wynik->insertHtml(QString::fromUtf8("Możesz wypić ") + QString::fromAscii(porcje) + QString::fromUtf8(" porcji \"") + ui.comboBox_ilosc->currentText() + QString::fromUtf8("\" o zawartości alkoholu ") + QString::number(ui.doubleSpinBox_zawartosc->value()) + QString::fromUtf8(" %."));
		}
		else
		{
			ui.textBrowser_wynik->insertHtml(QString::fromUtf8("Możesz wypić ") + QString::fromAscii(porcje) + QString::fromUtf8(" porcji ") + QString::number(ui.spinBox_ilosc->value()) + QString::fromUtf8("ml, czyli w sumie ") + QString::number(objetosc) + QString::fromUtf8(" ml") + QString::fromUtf8(" o zawartości alkoholu ") + QString::number(ui.doubleSpinBox_zawartosc->value()) + QString::fromUtf8(" %."));
		}
	}
	ui.textBrowser_wynik->insertHtml(QString::fromUtf8("<br>Rozkład alkoholu w czasie wygląda następująco:</br>"));
	wyswietl_tytul_tabeli();
	m_alk();
	ustaw_czas_rozpoczecia((int) pierwszy);

}

float Form1::oblicz_ilosc_plynow(float waga, float wspolczynnik)
{
	float ilosc=(waga-0.85*tluszcz(waga))*wspolczynnik;
	return ilosc;
}

void Form1::glowna (char plec, float masa,float ing)
{
	wspolczynnik=spytaj_o_plec(plec);
	waga=masa;
		
	if (ui.checkBox_bmi->isChecked())
	{
		ilosc_plynow=waga*wspolczynnik;
	}
	else
	{
		ilosc_plynow=oblicz_ilosc_plynow(waga,wspolczynnik);
	}

	ile_na_godz=ing*ilosc_plynow;

	wyswietl_tytul_tabeli();	
	m_alk();
	if (!ui.checkBox_bmi->isChecked())
	{
	bmi_info(waga); //wy?wietl informacje o bmi
	}
	else
	{
		ui.textBrowser_wynik->insertHtml(QString::fromUtf8("Uwaga - program nie uwzględnił współczynnika BMI (Jeśli możliwe jest, że masz nadwagę albo niedowagę - odznacz opcję \"Nie uwzględniaj współczynnika BMI\")"));

	}
}
