/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "promile-qt.h"
#include <iostream>
#include "dop_stez.h"
extern Form ui;
extern int nr_napoju;
extern int wyswietlono;
extern QFont czcionka_programu;
extern QFont czcionka_wynikow;
char pierwszy_dodany='n';
char plec;
extern float pierwszy;

Form1::Form1(QWidget * parent, Qt::WFlags f):QDialog(parent, f)
{
 ui.setupUi(this);
 QTextCodec::setCodecForTr (QTextCodec::codecForName ("ISO8859-2"));
 czytaj_konfiguracje();
 connect(ui.pushButton_dodaj, SIGNAL(clicked()), this, SLOT(kliknieto_dodaj()));
 connect(ui.pushButton_oblicz, SIGNAL(clicked()), this, SLOT(oblicz()));
 connect(ui.pushButton_kasuj, SIGNAL(clicked()), this, SLOT(kliknieto_kasuj()));
 connect(ui.comboBox_kraj, SIGNAL(currentIndexChanged(int)), this, SLOT(zmiana_kraju()));
 connect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
 connect(ui.spinBox_cz_wchl_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
 connect(ui.spinBox_cz_wchl_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
 connect(ui.pushButton_oblicz, SIGNAL(clicked()),this, SLOT(zapisz_konfiguracje()));
 connect(ui.pushButton_ok_pr, SIGNAL(clicked()),this,SLOT(wybierz_czcionke_programu()));
 connect(ui.pushButton_ok_wy, SIGNAL(clicked()),this,SLOT(wybierz_czcionke_wynikow()));
 connect(ui.pushButton_zapisz, SIGNAL(clicked()),this, SLOT(zapisz_konfiguracje()));
 connect(ui.comboBox_ilosc, SIGNAL(currentIndexChanged(int)), this, SLOT(zmiana_napoju_ilosci()));
 connect(ui.spinBox_ilosc, SIGNAL(valueChanged(int)),this,SLOT(zmiana_ilosci()));
 connect(ui.comboBox_zawartosc, SIGNAL(currentIndexChanged(int)), this, SLOT(zmiana_napoju_zawartosci()));
 connect(ui.doubleSpinBox_zawartosc, SIGNAL(valueChanged(double)),this,SLOT(zmiana_zawartosci()));
 connect(ui.spinBox_czas_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
 connect(ui.spinBox_czas_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
 connect(ui.spinBox_czas_dzien, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
 connect(ui.spinBox_czas_godz_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
 connect(ui.spinBox_czas_min_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
 connect(ui.spinBox_czas_dzien_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
 connect(ui.comboBox_czas_wchlaniania,SIGNAL(currentIndexChanged(int)),this,SLOT(zmiana_napelnienia_zoladka()));
}

void Form1::zmiana_napelnienia_zoladka()
{
disconnect(ui.spinBox_cz_wchl_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
disconnect(ui.spinBox_cz_wchl_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
ui.spinBox_cz_wchl_godz->setEnabled(false);
ui.spinBox_cz_wchl_min->setEnabled(false);
int godzina=ui.spinBox_cz_wchl_godz->value();
int minuta=ui.spinBox_cz_wchl_min->value();

 switch (ui.comboBox_czas_wchlaniania->currentIndex())
	{
		case 0:
			ui.spinBox_cz_wchl_godz->setEnabled(true);
			ui.spinBox_cz_wchl_min->setEnabled(true);
			break;
		case 1:
			godzina=0;
			minuta=45;
			break;
		case 2:
			godzina=1;
			minuta=20;
			break;
		case 3:
			godzina=2;
			minuta=0;
			break;
	}
	ui.spinBox_cz_wchl_godz->setValue(godzina);
	ui.spinBox_cz_wchl_min->setValue(minuta);
	connect(ui.spinBox_cz_wchl_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
	connect(ui.spinBox_cz_wchl_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
}

void Form1::kliknieto_dodaj()
{
	dodaj('n');	
}

void Form1::kliknieto_kasuj()
{
	kasuj('t');	
}

void Form1::dodaj(char czy_oblicz='n')
{
	float cz_wchl = ui.spinBox_cz_wchl_godz->value()*60 + (ui.spinBox_cz_wchl_min->value()) ;
	float cz_rozp = (ui.spinBox_czas_dzien->value()-1)*24.0*60 + ui.spinBox_czas_godz->value()*60 + (ui.spinBox_czas_min->value()); // czas rozpoczcia w godzinach
	dodaj_napoj(ui.spinBox_ilosc->value(),cz_rozp,ui.doubleSpinBox_zawartosc->value(),cz_wchl,ui.spinBox_dl_pic->value(),czy_oblicz);

	// zwiększenie czasu rozpoczecia picia nastepnego napoju o czas picia poprzedniego

};
//********************************************************************************
void Form1::kasuj(const char czy_kliknieto_kasuj='n')
{	
	ui.textBrowser_napoje->clear();
	ui.textBrowser_wynik->clear();
	pierwszy_dodany='n';
	if ((nr_napoju>1) || (czy_kliknieto_kasuj=='t') )
	{	
		ustaw_czas_rozpoczecia((int)pierwszy);
	}
	kasuj_napoje();
}


void Form1::zmiana_napoju_ilosci()
{
ui.spinBox_ilosc->setEnabled(false);
int obj;
float zawartosc;
switch(ui.comboBox_ilosc->currentIndex())
	{
	case 0:
		ui.spinBox_ilosc->setEnabled(true);
	case 1:
		obj=330;
		zawartosc=6;
		break;
	case 2:
		obj=500;
		zawartosc=6;
		break;
	case 3:
		obj=660;
		zawartosc=6;
		break;
	case 4:
		obj=100;
		zawartosc=12;
		break;
	case 5:
		obj=700;
		zawartosc=12;
		break;
	case 6: 
		obj=750;
		zawartosc=12;
		break;
	case 7:
		obj=1000;
		zawartosc=12;
		break;
	case 8:
		obj=25;
		zawartosc=40;
		break;
	case 9:
		obj=50;
		zawartosc=40;
		break;
	case 10:
		obj=100;
		zawartosc=40;
		break;
	case 11:
		obj=200;
		zawartosc=40;
		break;
	case 12:
		obj=500;
		zawartosc=40;
		break;
	case 13:
		obj=700;
		zawartosc=40;
		break;
	default:
		obj=500;
		zawartosc=6;
		break;
	}
	ui.spinBox_ilosc->setValue(obj);
	if (zawartosc==6 && ui.doubleSpinBox_zawartosc->value()>10)
	{
		ui.doubleSpinBox_zawartosc->setValue(zawartosc);
		ui.comboBox_zawartosc->setCurrentIndex(0);
	}
	if (zawartosc==12 && (ui.doubleSpinBox_zawartosc->value()>20 || (ui.doubleSpinBox_zawartosc->value()<10)))
	{
	         ui.doubleSpinBox_zawartosc->setValue(zawartosc);
		 ui.comboBox_zawartosc->setCurrentIndex(21); // przecitne wino 12 %
	}
	if (zawartosc==40 && ui.doubleSpinBox_zawartosc->value()<30)
	{
		ui.doubleSpinBox_zawartosc->setValue(zawartosc);
		ui.comboBox_zawartosc->setCurrentIndex(22); // przecitna wdka 40 %
	}
}

void Form1::zmiana_ilosci()
{
	if (ui.spinBox_ilosc->value()<=50)
	{
		ui.spinBox_dl_pic->setValue(1);
	}
	else
	ui.spinBox_dl_pic->setValue(45);
}

void Form1::zmiana_napoju_zawartosci()
{
ui.doubleSpinBox_zawartosc->setEnabled(false);
float zawartosc;
	disconnect(ui.doubleSpinBox_zawartosc, SIGNAL(valueChanged(double)),this,SLOT(zmiana_zawartosci()));
	switch(ui.comboBox_zawartosc->currentIndex())
	{
		case 0:
			ui.doubleSpinBox_zawartosc->setEnabled(true);
		case 1: //Carlsberg
			zawartosc=5.0; 
			break;
		case 2://Dbowe mocne
			zawartosc=7.0;
			break;
		case 3://Harna
			zawartosc=6.0;
			break;
		case 4://Heineken
			zawartosc=5.0;
			break;
		case 5://Karmi
			zawartosc=0.5;
			break;
		case 6://Lech
			zawartosc=5.2;
			break;
		case 7://Okocim palone
			zawartosc=5.5;
			break;
		case 8://Pilsner
			zawartosc=4.4;
			break;
		case 9://Redds
			zawartosc=4.5;
			break;
		case 10://Specjal czerwony
			zawartosc=6.7;
			break;
		case 11://Specjal czarny
			zawartosc=6.0;
			break;
		case 12://Tatra jasne pene
			zawartosc=6.0;
			break;
		case 13: //Tatra mocne
			zawartosc=7.0;
			break;
		case 14://Tyskie
			zawartosc=5.6;
			break;
		case 15://Warka
			zawartosc=5.7;
			break;
		case 16://Warka strong
			zawartosc=7.0;
			break;
		case 17://Zlaty Hrad
			zawartosc=6.6;
			break;
		case 18://ubr
			zawartosc=6.0;
			break;
		case 19://ywiec
			zawartosc=5.6;
			break;
		case 20://ywiec porter
			zawartosc=9.5;
			break;
		case 21://Przecitne wino
			zawartosc=12.0;
			break;
		case 22://Przecitna wdka
			zawartosc=40;
			break;
		default:
			zawartosc=5.6;
			break;
}
	ui.doubleSpinBox_zawartosc->setValue(zawartosc);
	connect(ui.doubleSpinBox_zawartosc, SIGNAL(valueChanged(double)),this,SLOT(zmiana_zawartosci()));
}

void Form1::zmiana_zawartosci()
{
	 ui.comboBox_zawartosc->setCurrentIndex(0);
}

void Form1::zmiana_kraju()
{
	disconnect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
	ui.doubleSpinBox_dop_stez->setValue(dopuszczalna[ui.comboBox_kraj->currentIndex()]);
	if (ui.comboBox_kraj->currentIndex()==0) {ui.doubleSpinBox_dop_stez->setEnabled(true);}
	else {ui.doubleSpinBox_dop_stez->setEnabled(false);}
	connect(ui.doubleSpinBox_dop_stez, SIGNAL(valueChanged(double)),this,SLOT(zmiana_dop_stez()));
}

void Form1::zmiana_dop_stez()
{
	ui.comboBox_kraj->setCurrentIndex(0);
}


void Form1::zmiana_czasu_picia()
{
	 disconnect(ui.spinBox_czas_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
	 disconnect(ui.spinBox_czas_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
	 disconnect(ui.spinBox_czas_dzien, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
	int minuty=ui.spinBox_czas_min->value();
        int godziny=ui.spinBox_czas_godz->value();
	int dzien=ui.spinBox_czas_dzien->value();
	if (ui.spinBox_czas_min->value() > 59)
	{
		ui.spinBox_czas_min->setValue(minuty-60);
		ui.spinBox_czas_godz->setValue(godziny+1);
	}
	if (ui.spinBox_czas_godz->value() > 23)
	{
		ui.spinBox_czas_godz->setValue(0);
		ui.spinBox_czas_dzien->setValue(dzien+1);
	}
	if (ui.spinBox_czas_min->value()<0 && ((dzien-1)*24+godziny)==0) 
	{
		ui.spinBox_czas_min->setValue(0);
	}	
	if (ui.spinBox_czas_min->value() < 0 && ((dzien-1)*24+godziny)>0)
	{
		ui.spinBox_czas_godz->setValue(godziny-1);
		ui.spinBox_czas_min->setValue(minuty+60);
	}
	
	if (ui.spinBox_czas_godz->value()<0 && ui.spinBox_czas_dzien->value()==1)
	{
		ui.spinBox_czas_godz->setValue(0);
	}
	
	if (ui.spinBox_czas_godz->value()<0 && ui.spinBox_czas_dzien->value()>1)
	{
		ui.spinBox_czas_godz->setValue(23);
		ui.spinBox_czas_dzien->setValue(ui.spinBox_czas_dzien->value()-1);
	}


	 connect(ui.spinBox_czas_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
	 connect(ui.spinBox_czas_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
	 connect(ui.spinBox_czas_dzien, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_picia()));
}

void Form1::zmiana_czasu_zakonczenia()
{
	 disconnect(ui.spinBox_czas_godz_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
	 disconnect(ui.spinBox_czas_min_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
	 disconnect(ui.spinBox_czas_dzien_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
	int minuty=ui.spinBox_czas_min_2->value();
        int godziny=ui.spinBox_czas_godz_2->value();
	int dzien=ui.spinBox_czas_dzien_2->value();
	if (ui.spinBox_czas_min_2->value() > 59)
	{
		ui.spinBox_czas_min_2->setValue(minuty-60);
		ui.spinBox_czas_godz_2->setValue(godziny+1);
	}
	if (ui.spinBox_czas_godz_2->value() > 23)
	{
		ui.spinBox_czas_godz_2->setValue(0);
		ui.spinBox_czas_dzien_2->setValue(dzien+1);
	}
	if (ui.spinBox_czas_min_2->value()<0 && ((dzien-1)*24+godziny)==0) 
	{
		ui.spinBox_czas_min_2->setValue(0);
	}	
	if (ui.spinBox_czas_min_2->value() < 0 && ((dzien-1)*24+godziny)>0)
	{
		ui.spinBox_czas_godz_2->setValue(godziny-1);
		ui.spinBox_czas_min_2->setValue(minuty+60);
	}
	
	if (ui.spinBox_czas_godz_2->value()<0 && ui.spinBox_czas_dzien_2->value()==1)
	{
		ui.spinBox_czas_godz_2->setValue(0);
	}
	
	if (ui.spinBox_czas_godz_2->value()<0 && ui.spinBox_czas_dzien_2->value()>1)
	{
		ui.spinBox_czas_godz_2->setValue(23);
		ui.spinBox_czas_dzien_2->setValue(ui.spinBox_czas_dzien_2->value()-1);
	}


	 connect(ui.spinBox_czas_godz_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
	 connect(ui.spinBox_czas_min_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
	 connect(ui.spinBox_czas_dzien_2, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_zakonczenia()));
}

void Form1::zmiana_czasu_wchlaniania()
{
disconnect(ui.spinBox_cz_wchl_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
disconnect(ui.spinBox_cz_wchl_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
ui.comboBox_czas_wchlaniania->setCurrentIndex(0);
	if (ui.spinBox_cz_wchl_godz->value() == 0)
	{
		if (ui.spinBox_cz_wchl_min->value() < 30)
		{
			ui.spinBox_cz_wchl_min->setValue(30);
		}
	}
	if (ui.spinBox_cz_wchl_min->value() > 59)
	{
		int minuty=ui.spinBox_cz_wchl_min->value();
		int godziny=ui.spinBox_cz_wchl_godz->value();
		ui.spinBox_cz_wchl_min->setValue(minuty-60);
		ui.spinBox_cz_wchl_godz->setValue(godziny+1);

	}

	if (ui.spinBox_cz_wchl_min->value() < 0)
	{
		int minuty=ui.spinBox_cz_wchl_min->value();
		int godziny=ui.spinBox_cz_wchl_godz->value();
		ui.spinBox_cz_wchl_godz->setValue(godziny-1);
		ui.spinBox_cz_wchl_min->setValue(minuty+60);
        }
connect(ui.spinBox_cz_wchl_godz, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
connect(ui.spinBox_cz_wchl_min, SIGNAL(valueChanged(int)),this,SLOT(zmiana_czasu_wchlaniania()));
}

void Form1::wybierz_czcionke_wynikow()
{
czcionka_wynikow.setPointSize(ui.spinBox_cz_wy_wi->value());
ustaw_czcionke_wynikow(czcionka_wynikow);
}

void Form1::ustaw_czcionke_wynikow(QFont font)
{
	ui.textBrowser_wynik->setFont(font);
}

void Form1::wybierz_czcionke_programu()
{
czcionka_programu.setPointSize(ui.spinBox_cz_pr_wi->value());
ustaw_czcionke_programu(czcionka_programu);
}

void Form1::ustaw_czcionke_programu(QFont font)
{
ui.groupBox_5->setFont(font);
ui.groupBox->setFont(font);
ui.radioButton_m->setFont(font);
ui.radioButton_k->setFont(font);
ui.label->setFont(font);
ui.spinBox_waga->setFont(font);
ui.label_2->setFont(font);
ui.doubleSpinBox_prom_na_godz->setFont(font);
ui.groupBox_2->setFont(font);
ui.label_10->setFont(font);
ui.label_3->setFont(font);
ui.spinBox_ilosc->setFont(font);
ui.label_zawartosc->setFont(font);
ui.doubleSpinBox_zawartosc->setFont(font);
ui.label_7->setFont(font);
ui.spinBox_czas_godz->setFont(font);
ui.spinBox_czas_min->setFont(font);
ui.label_4->setFont(font);
ui.spinBox_dl_pic->setFont(font);
ui.groupBox_3->setFont(font);
ui.spinBox_cz_wchl_godz->setFont(font);
ui.spinBox_cz_wchl_min->setFont(font);
ui.pushButton_dodaj->setFont(font);
ui.pushButton_kasuj->setFont(font);
ui.pushButton_oblicz->setFont(font);
ui.tabWidget->setFont(font);
ui.label_6->setFont(font);
ui.spinBox_co_ile->setFont(font);
ui.label_14->setFont(font);
ui.doubleSpinBox_dawka_smiertelna->setFont(font);
ui.spinBox_czas_dzien->setFont(font);
ui.label_15->setFont(font);
ui.label_16->setFont(font);
ui.label_17->setFont(font);
ui.label_18->setFont(font);
ui.spinBox_cz_wy_wi->setFont(font);
ui.spinBox_cz_pr_wi->setFont(font);
ui.pushButton_ok_wy->setFont(font);
ui.pushButton_ok_pr->setFont(font);
ui.groupBox_8->setFont(font);
ui.toolBox_4->setFont(font);
ui.radioButton_stala_szybkosc->setFont(font);
ui.radioButton_zmienna_szybkosc->setFont(font);
ui.label_20->setFont(font);
ui.doubleSpinBox_maxg_na_godz->setFont(font);
ui.pushButton_koniec->setFont(font);
ui.comboBox_czas_wchlaniania->setFont(font);
ui.checkBox_bmi->setFont(font);
ui.label_22->setFont(font);
ui.spinBox_czas_kieliszki->setFont(font);
ui.label_5->setFont(font);
ui.label_8->setFont(font);
ui.spinBox_czas_dzien_2->setFont(font);
ui.label_19->setFont(font);
ui.spinBox_czas_godz_2->setFont(font);
ui.label_21->setFont(font);
ui.spinBox_czas_min_2->setFont(font);

}
void Form1::ustaw_czas_rozpoczecia(int czas)
{
	int cz_rozp_dzien = int (czas/(24.0*60));
	int cz_rozp_godz = int ((czas - cz_rozp_dzien*24.0*60)/60.0);
	int cz_rozp_min = int ((czas - 24.0*60*cz_rozp_dzien - cz_rozp_godz*60)+0.5);
	ui.spinBox_czas_godz->setValue(cz_rozp_godz);
	ui.spinBox_czas_min->setValue(cz_rozp_min);
	ui.spinBox_czas_dzien->setValue(cz_rozp_dzien+1);
}

void Form1::ustaw_czas_zakonczenia(int czas)
{
	int cz_rozp_dzien = int (czas/(24.0*60));
	int cz_rozp_godz = int ((czas - cz_rozp_dzien*24.0*60)/60.0);
	int cz_rozp_min = int ((czas - 24.0*60*cz_rozp_dzien - cz_rozp_godz*60)+0.5);
	ui.spinBox_czas_godz_2->setValue(cz_rozp_godz);
	ui.spinBox_czas_min_2->setValue(cz_rozp_min);
	ui.spinBox_czas_dzien_2->setValue(cz_rozp_dzien+1);
}


void Form1::oblicz()
{
	
	if (ui.radioButton_m->isChecked()) {plec='m';}
	else plec='k';

	if (ui.tabWidget_3->currentIndex()==1)  // jeeli tryb "ile moge wypic"
	{
		oblicz_ile_moge_wypic(ui.spinBox_waga->value(),plec);
		return;
	}
	wyswietlono=0;
	ui.textBrowser_wynik->clear();
	if (nr_napoju<=1 && pierwszy_dodany=='n')
	{
		kasuj();
		dodaj('t');
	
	}
	glowna(plec, ui.spinBox_waga->value(),ui.doubleSpinBox_prom_na_godz->value());
}
