/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ui_promile-qt.h"
#include <QMessageBox>
#include <QDialog>
#include <QTextCodec>
#include <QFontDialog>
#include <QFont>
#define WERSJA "0.8.0"
extern void kasuj_napoje();
using namespace Ui;

class Form1: public QDialog
{
Q_OBJECT

public:
   Form ui;
   Form1(QWidget * parent = 0, Qt::WFlags f = 0 );
   ~Form1(){};
   void glowna(char plec,float masa,float ing);
   void dodaj_napoj(int ilosc, float godzina, float stezenie, float cz_wchl, int dl_pic, char czy_oblicz);
   void rysuj_wykres();
   void bmi_info(float waga);
   float tluszcz(float waga);
   void wyswietl_tytul_tabeli();
   void wyswietl_wynik(float wynik);
   void dodaj(const char czy_oblicz);
   void kasuj(const char czy_kliknieto_kasuj);
   void ustaw_czcionke_programu(QFont font);
   void ustaw_czcionke_wynikow(QFont font);
   void ustaw_czas_rozpoczecia(int czas);
   void ustaw_czas_zakonczenia(int czas);
   void oblicz_ile_moge_wypic(int waga, char plec);
   int czas_na_minuty(int dzien, int godzina, int minuta);
   float oblicz_ilosc_plynow(float waga, float wspolczynnik);
   float m_alk(char tryb);
   float promile(float czas);
 public slots:
   void zmiana_napelnienia_zoladka();
   void zmiana_czasu_picia();
   void zmiana_czasu_zakonczenia();
   void czytaj_konfiguracje();
   void zapisz_konfiguracje();
   void zmiana_kraju();
   void zmiana_ilosci();
   void zmiana_napoju_ilosci();
   void zmiana_dop_stez();
   void zmiana_zawartosci();
   void zmiana_napoju_zawartosci();
   void kliknieto_dodaj();
   void oblicz();
   void kliknieto_kasuj();
   void wybierz_czcionke_wynikow();
   void wybierz_czcionke_programu();
   void zmiana_czasu_wchlaniania();
};


